#include<algorithm>
#include<cstdio>
#include<cassert>
#include<iostream>
#include<vector>
#include <map>
using namespace std;

void output(int r, int c, bool swp) {
  if (swp) swap(r, c);
  cout << (r+1) << " " << (c+1) << endl;
}

void print(bool swp, vector<pair<int, int> >& v) {
  for(int i=0; i<(int)v.size(); ++i) output(v[i].first, v[i].second, swp);
  cout << endl;
}

void print_debug(vector<pair<int,int> > v) {
  int lor, loc, hir, hic;
  lor = hir = v[0].first;
  loc = hic = v[0].second;
  for(int i=0; i<(int)v.size(); ++i) {
    lor = min(lor, v[i].first);
    loc = min(loc, v[i].second);
    hir = max(hir, v[i].first);
    hic = max(hic, v[i].second);
  }
  int ofr = -lor;
  int ofc = -loc;
  vector<vector<int> > M(hir-lor+1, vector<int>(hic-loc+1, -1));
  for(int i=0; i<(int)v.size(); ++i)
    M[ ofr + v[i].first ][ ofc + v[i].second ] = i;
  for(int i=0; i<(int)M.size(); ++i) {
    for(int j=0; j<(int)M[i].size(); ++j)
      if (M[i][j] >= 0) printf("%4d ", M[i][j]);
      else printf("     ");
    printf("\n");
  }
  printf("\n");
}

void diagonal(int r, int c, int step, vector<pair<int, int> >& ret) {
  for(int s=0; s<step-1; ++s) ret.push_back({r+s,c-s});
  ret.push_back({r-1, c+1});
}

int pattern(int R, int C, int F, vector<pair<int, int> >& ret) {
  int r, c, step=0;

  if (F == 'B') { ret.push_back({1,0}); ret.push_back({0,1}); r = 1, c = 2, step=min(R,4); }
  if (F == 'W') { ret.push_back({0,0});                       r = 1, c = 1, step=3; }
  while(c+2<C) {
    diagonal(r, c, step, ret);
    c += 2;
    step = min(step+2, R);
  }
  return c;
}

int main(void) {
  int T, R, C;
  char F;
  bool swapped;

  cin >> T;
  while(T > 0) {
    cin >> R >> C >> F;
    --T;
    assert(F == 'B' || F == 'W');
    if (R > C) { swap(R, C); swapped = true; }
    else swapped = false;

    assert(R * C >= 2);
    if (R == 1 && C <= 2 && F == 'W') { output(0, 0, swapped); cout << endl; continue; }
    if (R == 1 && 2 <= C && C <= 3 && F == 'B') { output(0, 1, swapped); cout << endl; continue; }
    if (R == 2) { for(int i=0; i<C; ++i) output( (i+(F=='B')) % 2, i, swapped); cout << endl; continue; }
    if (R >= 3) {
      vector<pair<int, int> > ret1, ret2;
      int c = pattern(R, C, F, ret1);
      if (R == 3) {
        if (c == C-1) {
          ret1.push_back({R-2, C-1}); ret1.push_back({R-1, C-2});
        } else {
          ret1.push_back({R-1, C-1}); ret1.push_back({R-2, C-2}); ret1.push_back({R-1, C-3}); ret1.push_back({R-3, C-1});
        }
      }
      else {
        diagonal(1, c, R-2, ret1);
        if (c == C-1) ret1.pop_back();
        ret1.push_back({R-1, c-R+2});
        ret1.push_back({R-2, c-R+3});
    
        pattern(R, R-1, ((R%2==C%2) ^ (F == 'W')) ? 'B' : 'W', ret2);
        reverse(ret2.begin(), ret2.end());
        for(int i=0; i<(int)ret2.size(); ++i) ret1.push_back({R-1-ret2[i].first, C-1-ret2[i].second});
      }
      print(swapped, ret1);
      continue;
    }
    cout << "impossible" << endl << endl;
  }
  return 0;
}
